Getting Started with PowerButton Web Component
Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.
Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.
Quick start
- Install the package:
npm install smart-webcomponents
- Load the PowerButton module (ES module script):
<script type="module" src="node_modules/smart-webcomponents/source/modules/smart.powerbutton.js"></script>
- Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):
<link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />
- Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host
div(you mount programmatically with appendTo):
Semantic element (id matches the selector in Smart()):
<smart-power-button id="powerbutton"></smart-power-button>
Host container (id matches appendTo on Smart.PowerButton):
<div id="powerbuttonContainer"></div>
- Initialize after the module loads: define a const powerbuttonOptions object, then either bind with Smart('#powerbutton', ...) on the semantic tag or use new Smart.PowerButton({ ...powerbuttonOptions, appendTo: '#powerbuttonContainer' }) on the host
div:
<script type="module"> import 'node_modules/smart-webcomponents/source/modules/smart.powerbutton.js'; const powerbuttonOptions = {}; // Option A - semantic <smart-power-button> with id="powerbutton" Smart('#powerbutton', class { get properties() { return powerbuttonOptions; } }); // Option B - host div id="powerbuttonContainer" // const powerbuttonInstance = new Smart.PowerButton({ // ...powerbuttonOptions, // appendTo: '#powerbuttonContainer' // }); // Option C - constructor(selector, options), then append the returned element yourself // const myPowerButton = new Smart.PowerButton('#powerbutton', powerbuttonOptions); // document.body.appendChild(myPowerButton); </script>
Uncomment Option B when you use the host
div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.PowerButton('#powerbutton', powerbuttonOptions) with appendChild, and document.createElement('smart-power-button') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components). - Serve the folder over HTTP (or use your bundler dev server) and open the page.
Runtime cookbook
Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.PowerButton({ ...options, appendTo: '#...' }); new Smart.PowerButton('#powerbutton', powerbuttonOptions) plus appendChild on the returned element; and document.createElement('smart-power-button') then assigning options via .props or Object.assign on the element.
Constructor with a selector string and options, then append the returned element (for example const myPowerButton = new Smart.PowerButton('#powerbutton', powerbuttonOptions)):
const powerbuttonOptions = {};
const myPowerButton = new Smart.PowerButton('#powerbutton', powerbuttonOptions);
document.body.appendChild(myPowerButton);
Create with document.createElement('smart-power-button'), assign properties (same as any custom element), then append:
const powerbuttonOptions = {};
const powerbutton = document.createElement('smart-power-button');
Object.assign(powerbutton, powerbuttonOptions);
document.body.appendChild(powerbutton);
Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):
import "../../source/modules/smart.powerbutton.js";
document.readyState === 'complete' ? init() : window.addEventListener('load', init);
function init() {
const powerbuttonOptions = {};
const powerbutton = new Smart.PowerButton({
...powerbuttonOptions,
appendTo: '#powerbuttonContainer'
});
}
Append to the DOM:
const container = document.getElementById('powerbutton-container');
container.appendChild(powerbutton);
Remove from the DOM:
powerbutton.remove();
Set a property:
powerbutton.disabled = true; powerbutton.theme = 'dark';
Get a property value:
const isDisabled = powerbutton.disabled; const currentTheme = powerbutton.theme;
Invoke a method:
powerbutton.refresh(); powerbutton.focus();
Add event listener:
powerbutton.addEventListener('change', (event) => {
console.log('change triggered:', event.detail);
});
Remove event listener:
const handlePowerButtonEvent = (event) => {
console.log('change triggered:', event.detail);
};
powerbutton.addEventListener('change', handlePowerButtonEvent);
powerbutton.removeEventListener('change', handlePowerButtonEvent);
Accessibility
The PowerButton component follows WAI-ARIA best practices:
- Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
- ARIA roles - Appropriate roles and labels are applied automatically
- Focus management - Visible focus indicators for keyboard users
- Screen readers - State changes are announced to assistive technology
- High contrast - Supports Windows High Contrast Mode and forced colors
For custom labeling, set aria-label or aria-labelledby attributes on the component.
Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React PowerButton Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/powerbutton/overview/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import React from "react";
import ReactDOM from 'react-dom/client';
import { PowerButton } from "smart-webcomponents-react/button";
import { CircularProgressBar } from "smart-webcomponents-react/progressbar";

class App extends React.Component {

	componentDidMount() {

	}

	render() {
		return (
			<div>
				<div className="smart-demo-container">
					<section id="power-button">
						<div className="module">
							<p>Power button is a two-state type of toggle button with an indicator.</p>
							<p>Used as indicator.</p>
						</div>
						<div className="module power-button-flat-light">
							<div>
								<PowerButton></PowerButton>
								<br />
								<PowerButton hover></PowerButton>
								<br />
								<PowerButton checked></PowerButton>
								<br />
								<PowerButton disabled></PowerButton>
							</div>
						</div>
						<div className="module"></div>
						<div className="module power-button-light">
							<div>
								<PowerButton className="raised"></PowerButton>
								<br />
								<PowerButton className="raised"></PowerButton>
								<br />
								<PowerButton className="checked raised" checked></PowerButton>
								<br />
								<PowerButton className="raised" disabled></PowerButton>
							</div>
							<p>Raised Power button</p>
						</div>
						<div className="module power-button-dark">
							<h2>Demo usage</h2>
						</div>
						<div className="module power-button">
							<div>
								<CircularProgressBar id="progressBarAnimated" indeterminate value={100}>
									<PowerButton style={{ border: "none" }} id="powerButtonAnimation"></PowerButton>
								</CircularProgressBar>
							</div>
							<p>A power button can control the loading process.</p>
						</div>
					</section>
				</div>
			</div>
		);
	}
}



export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { PowerButton, PowerButtonProps } from 'smart-webcomponents-react/powerbutton';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The PowerButton component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular PowerButton - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/powerbutton/overview

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import PowerButtonModule from smart-webcomponents-angular/powerbutton: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { PowerButtonModule } from 'smart-webcomponents-angular/powerbutton';

4 Root component (standalone)

Add PowerButtonModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { PowerButtonComponent } from 'smart-webcomponents-angular/button';
import { ProgressBar } from 'smart-webcomponents-angular/progressbar';


import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { PowerButtonModule } from 'smart-webcomponents-angular/powerbutton';

@Component({
	selector: 'app-root',
	standalone: true,
	imports: [CommonModule, PowerButtonModule, RouterOutlet],
	templateUrl: './app.html',
	styleUrls: ['./app.css']
})

export class App implements AfterViewInit, OnInit {
	@ViewChild('powerbutton', { read: PowerButtonComponent, static: false }) powerbutton!: PowerButtonComponent;
	@ViewChild('powerbutton2', { read: PowerButtonComponent, static: false }) powerbutton2!: PowerButtonComponent;
	@ViewChild('powerbutton3', { read: PowerButtonComponent, static: false }) powerbutton3!: PowerButtonComponent;
	@ViewChild('powerbutton4', { read: PowerButtonComponent, static: false }) powerbutton4!: PowerButtonComponent;
	@ViewChild('powerbutton5', { read: PowerButtonComponent, static: false }) powerbutton5!: PowerButtonComponent;
	@ViewChild('powerbutton6', { read: PowerButtonComponent, static: false }) powerbutton6!: PowerButtonComponent;
	@ViewChild('powerbutton7', { read: PowerButtonComponent, static: false }) powerbutton7!: PowerButtonComponent;
	@ViewChild('powerbutton8', { read: PowerButtonComponent, static: false }) powerbutton8!: PowerButtonComponent;


	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
	}

	init(): void {
		// init code.


		document.getElementById('powerButtonAnimation')
			?.addEventListener('change', function (event: any) {
				(document.getElementById('progressBarAnimated') as ProgressBar).indeterminate =
					event.detail.value ? false : true;
			});


	}
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-power-button as needed:

 <div class="smart-demo-container">
    <section id="power-button">
        <div class="module">
            <p>Power button is a two-state type of toggle button with an indicator.</p>
            <p>Used as indicator.</p>
        </div>
        <div class="module power-button-flat-light">
            <div>
                <smart-power-button></smart-power-button>
                <br />
                <smart-power-button #powerbutton hover></smart-power-button>
                <br />
                <smart-power-button #powerbutton2 [checked]="true"></smart-power-button>
                <br />
                <smart-power-button #powerbutton3 [disabled]="true"></smart-power-button>
            </div>
        </div>
        <div class="module"></div>
        <div class="module power-button-light">
            <div>
                <smart-power-button #powerbutton4 class="raised"></smart-power-button>
                <br />
                <smart-power-button #powerbutton5 class="raised"></smart-power-button>
                <br />
                <smart-power-button #powerbutton6 class="checked raised" [checked]="true"></smart-power-button>
                <br />
                <smart-power-button #powerbutton7 class="raised" [disabled]="true"></smart-power-button>
            </div>
            <p>Raised Power button</p>
        </div>
        <div class="module power-button-dark">
             <h2>Demo usage</h2>
        </div>
        <div class="module power-button">
            <div>
                <smart-circular-progress-bar id="progressBarAnimated" [indeterminate]="true" [value]="100">
                    <smart-power-button #powerbutton8 style="border:none;" id="powerButtonAnimation"></smart-power-button>
                </smart-circular-progress-bar>
            </div>
            <p>A power button can control the loading process.</p>
        </div>
    </section>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put PowerButtonModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

Sample NgModule layout from Smart UI demos (app.component.*, app.module.ts):

app.component.html

 <div class="smart-demo-container">
    <section id="power-button">
        <div class="module">
            <p>Power button is a two-state type of toggle button with an indicator.</p>
            <p>Used as indicator.</p>
        </div>
        <div class="module power-button-flat-light">
            <div>
                <smart-power-button></smart-power-button>
                <br />
                <smart-power-button #powerbutton hover></smart-power-button>
                <br />
                <smart-power-button #powerbutton2 [checked]="true"></smart-power-button>
                <br />
                <smart-power-button #powerbutton3 [disabled]="true"></smart-power-button>
            </div>
        </div>
        <div class="module"></div>
        <div class="module power-button-light">
            <div>
                <smart-power-button #powerbutton4 class="raised"></smart-power-button>
                <br />
                <smart-power-button #powerbutton5 class="raised"></smart-power-button>
                <br />
                <smart-power-button #powerbutton6 class="checked raised" [checked]="true"></smart-power-button>
                <br />
                <smart-power-button #powerbutton7 class="raised" [disabled]="true"></smart-power-button>
            </div>
            <p>Raised Power button</p>
        </div>
        <div class="module power-button-dark">
             <h2>Demo usage</h2>
        </div>
        <div class="module power-button">
            <div>
                <smart-circular-progress-bar id="progressBarAnimated" [indeterminate]="true" [value]="100">
                    <smart-power-button #powerbutton8 style="border:none;" id="powerButtonAnimation"></smart-power-button>
                </smart-circular-progress-bar>
            </div>
            <p>A power button can control the loading process.</p>
        </div>
    </section>
</div>

app.component.ts

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { PowerButtonComponent } from 'smart-webcomponents-angular/button';
import { ProgressBar } from 'smart-webcomponents-angular/progressbar';


@Component({
	selector: 'app-root',
	templateUrl: './app.component.html',
	styleUrls: ['./app.component.css']
})

export class AppComponent implements AfterViewInit, OnInit {
	@ViewChild('powerbutton', { read: PowerButtonComponent, static: false }) powerbutton!: PowerButtonComponent;
	@ViewChild('powerbutton2', { read: PowerButtonComponent, static: false }) powerbutton2!: PowerButtonComponent;
	@ViewChild('powerbutton3', { read: PowerButtonComponent, static: false }) powerbutton3!: PowerButtonComponent;
	@ViewChild('powerbutton4', { read: PowerButtonComponent, static: false }) powerbutton4!: PowerButtonComponent;
	@ViewChild('powerbutton5', { read: PowerButtonComponent, static: false }) powerbutton5!: PowerButtonComponent;
	@ViewChild('powerbutton6', { read: PowerButtonComponent, static: false }) powerbutton6!: PowerButtonComponent;
	@ViewChild('powerbutton7', { read: PowerButtonComponent, static: false }) powerbutton7!: PowerButtonComponent;
	@ViewChild('powerbutton8', { read: PowerButtonComponent, static: false }) powerbutton8!: PowerButtonComponent;


	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
	}

	init(): void {
		// init code.


		document.getElementById('powerButtonAnimation')
			?.addEventListener('change', function (event: any) {
				(document.getElementById('progressBarAnimated') as ProgressBar).indeterminate =
					event.detail.value ? false : true;
			});


	}
}

app.module.ts

 import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { ButtonModule } from 'smart-webcomponents-angular/button';
import { ProgressBarModule } from 'smart-webcomponents-angular/progressbar';

import { AppComponent } from './app.component';

@NgModule({
    declarations: [ AppComponent ],
    imports: [ BrowserModule, ButtonModule, ProgressBarModule ],
    bootstrap: [ AppComponent ]
})

export class AppModule { }

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The PowerButton component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.